题目描述
给你一个数组 time
,其中 time[i]
表示第 i
辆公交车完成 一趟旅途 所需要花费的时间。
每辆公交车可以 连续 完成多趟旅途,也就是说,一辆公交车当前旅途完成后,可以 立马开始 下一趟旅途。每辆公交车 独立 运行,也就是说可以同时有多辆公交车在运行且互不影响。
给你一个整数 totalTrips
,表示所有公交车 总共 需要完成的旅途数目。请你返回完成 至少 totalTrips
趟旅途需要花费的 最少 时间。
示例 1:
输入:time = [1,2,3], totalTrips = 5
输出:3
解释:
- 时刻 t = 1 ,每辆公交车完成的旅途数分别为 [1,0,0] 。
已完成的总旅途数为 1 + 0 + 0 = 1 。
- 时刻 t = 2 ,每辆公交车完成的旅途数分别为 [2,1,0] 。
已完成的总旅途数为 2 + 1 + 0 = 3 。
- 时刻 t = 3 ,每辆公交车完成的旅途数分别为 [3,1,1] 。
已完成的总旅途数为 3 + 1 + 1 = 5 。
所以总共完成至少 5 趟旅途的最少时间为 3 。
示例 2:
输入:time = [2], totalTrips = 1
输出:2
解释:
只有一辆公交车,它将在时刻 t = 2 完成第一趟旅途。
所以完成 1 趟旅途的最少时间为 2 。
提示:
1 <= time.length <= 105
1 <= time[i], totalTrips <= 107
解法
方法一:二分查找
我们注意到,如果我们能在 $t$ 时间内至少完成 $totalTrips$ 趟旅途,那么在 $t' > t$ 时间内也能至少完成 $totalTrips$ 趟旅途。因此我们可以使用二分查找的方法来找到最小的 $t$。
我们定义二分查找的左边界 $l = 1$,右边界 $r = \min(time) \times \textit{totalTrips}$。每一次二分查找,我们计算中间值 $\textit{mid} = \frac{l + r}{2}$,然后计算在 $\textit{mid}$ 时间内能完成的旅途数目。如果这个数目大于等于 $\textit{totalTrips}$,那么我们将右边界缩小到 $\textit{mid}$,否则我们将左边界扩大到 $\textit{mid} + 1$。
最后返回左边界即可。
时间复杂度 $O(n \times \log(m \times k))$,其中 $n$ 和 $k$ 分别是数组 $time$ 的长度和 $totalTrips$,而 $m$ 是数组 $time$ 中的最小值。空间复杂度 $O(1)$。
| class Solution:
def minimumTime(self, time: List[int], totalTrips: int) -> int:
mx = min(time) * totalTrips
return bisect_left(
range(mx), totalTrips, key=lambda x: sum(x // v for v in time)
)
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22 | class Solution {
public long minimumTime(int[] time, int totalTrips) {
int mi = time[0];
for (int v : time) {
mi = Math.min(mi, v);
}
long left = 1, right = (long) mi * totalTrips;
while (left < right) {
long cnt = 0;
long mid = (left + right) >> 1;
for (int v : time) {
cnt += mid / v;
}
if (cnt >= totalTrips) {
right = mid;
} else {
left = mid + 1;
}
}
return left;
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20 | class Solution {
public:
long long minimumTime(vector<int>& time, int totalTrips) {
int mi = *min_element(time.begin(), time.end());
long long left = 1, right = 1LL * mi * totalTrips;
while (left < right) {
long long cnt = 0;
long long mid = (left + right) >> 1;
for (int v : time) {
cnt += mid / v;
}
if (cnt >= totalTrips) {
right = mid;
} else {
left = mid + 1;
}
}
return left;
}
};
|
| func minimumTime(time []int, totalTrips int) int64 {
mx := slices.Min(time) * totalTrips
return int64(sort.Search(mx, func(x int) bool {
cnt := 0
for _, v := range time {
cnt += x / v
}
return cnt >= totalTrips
}))
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14 | function minimumTime(time: number[], totalTrips: number): number {
let left = 1n;
let right = BigInt(Math.min(...time)) * BigInt(totalTrips);
while (left < right) {
const mid = (left + right) >> 1n;
const cnt = time.reduce((acc, v) => acc + mid / BigInt(v), 0n);
if (cnt >= BigInt(totalTrips)) {
right = mid;
} else {
left = mid + 1n;
}
}
return Number(left);
}
|